let tgapi = require('node-telegram-bot-api');
let EventEmitter = require("events").EventEmitter;
let util = require("util");

class tg {
  constructor(options) {
    EventEmitter.call(this);
    this.options = options || {};
    this.token = options.token || null;
    this.options.polling = options.polling || true;
    this.client = new tgapi(this.options.token, this.options);

    this.client.on('message', msg => {
      let time = ~~(Date.now() / 1000);
      if (msg.date >= (time - 10))
        this.emit('message', this.reply(msg));
    });
  }
  send(id, msg) {
    this.client.sendMessage(id, msg);
  }
  reply(tmp) {
    console.log("Telegram", tmp);
    return {
      type: "tg",
      network: "Telegram",
      channel: tmp.chat.title,
      channelid: tmp.chat.id,
      user: {
        nick: tmp.from.first_name,
        username: tmp.from.username,
        hostname: tmp.from.id
      },
      message: tmp.text,
      time: tmp.date,
      raw: tmp,
      reply: function (msg) {
        this.send(tmp.chat.id, msg);
      },
      replyAction: function (msg) {
        this.send(tmp.chat.id, msg);
      },
      replyNotice: function (msg) {
        this.send(tmp.chat.id, msg);
      }
    };
  }
}

module.exports = tg;
util.inherits(tg, EventEmitter);